<?php
header('Content-type: text/xml');

//
//  Yhdist tietokantaan
//
function connect() {

	global $connection;
	
	try {
		$connection = new PDO("mysql:host=db1.kapsi.fi;dbname=magetsu","magetsu","FgQiYWtkRX");
	} catch (PDOException $e) {
    	die("VIRHE: " . $e->getMessage());
	}
	
    $connection->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);	
    $connection->exec("set names utf8");
}

//
//   Kirjautumisen tarkistaminen tietokannasta
//
function login($username,$password) {

	global $connection;
	
	connect();

	$user_id = 0;
	
	try {
		$user = array($username,$password);

		$sql = "SELECT user_id, username, password FROM accounts WHERE username = ? AND password = ?";
		
		$query = $connection->prepare($sql);
	
		$query->execute($user);
		
		$user_id = $query->fetchColumn();
		
	} catch(Exception $e) {
		/*** if we are here, something has gone wrong with the database ***/
		echo 'We are unable to process your request. Please try again later';
	}
	return $user_id;
}

//
//   Listn uusi kyttj tietokantaan
//
function add_account($username,$password) {

	global $connection;
		
	connect();
	
	$account = true;
	
	try {
		
		$user = array($username,$password);
		$sql = "INSERT INTO accounts (username, password) VALUES (?, ?)";
			
		$query = $connection->prepare($sql);
				
		$query->execute($user);
	} catch(Exception $e) {
		
        /*** check if the username already exists ***/
        if( $e->getCode() == 23000) {
        	
        	$account = false;
            echo 'Kyttjnimi on jo kytss';
        } else {
        	
        	$account = false;
        	/*** if we are here, something has gone wrong with the database ***/
            echo 'We are unable to process your request. Please try again later';
        }
    }
	return $account;
}
	
//
//   Tarkistetaan tietokanta
//
function is_database_ok() {
	
	global $connection;
	
	$sql = 'SHOW TABLES';
	$query = $connection->prepare($sql);
	$query->execute();
	if ($query->rowCount()!=0) {
		
		return true;
	} else {
		
		return false;
	}
}

//
//   Tarkistetaan tietokanta
//
function is_library_ok($user_id) {

	global $connection;

	$book_table = $user_id.'book';
	$dvd_table = $user_id.'dvd';
	
	$sql = 'SHOW TABLES';
	$query = $connection->prepare($sql);
	$query->execute();
	$array = $query->fetchAll(PDO::FETCH_COLUMN, 0);
	if (in_array($book_table,$array) && in_array($dvd_table,$array)) {
		
		return true;
	}
	return false;
}

//
// Luodaan kyttjtaulu tietokantaan
//
function create_accounttable() {

	global $connection;

	$sql="CREATE TABLE IF NOT EXISTS magetsu.accounts ( user_id int(11) NOT NULL auto_increment,
													   username VARCHAR(20) NOT NULL,
													   password VARCHAR(40) NOT NULL,
													   PRIMARY KEY (user_id),
													   UNIQUE KEY username (username))";

	$query = $connection->prepare($sql);
	$query->execute();
}

// Luodaan kirjastotaulut tietokantaan
function create_library_tables($user_id) {

	global $connection;
	$table = $user_id.'book';
	
	$sql = "DROP TABLE IF EXISTS $table";
	$query = $connection->prepare($sql);
	$query->execute();
		
	$sql="CREATE TABLE IF NOT EXISTS magetsu.$table ( surname VARCHAR(15) NOT NULL,
													forename VARCHAR(20) NOT NULL,
													bookname VARCHAR(100) NOT NULL,
													pubyear INT NOT NULL,
													isbn VARCHAR(20) NOT NULL,
													orgname VARCHAR(100) NOT NULL,
													orgyear INT NOT NULL,
													other VARCHAR(1000) NOT NULL)";

	$query = $connection->prepare($sql);
	$query->execute();
	
	$table = $user_id.'dvd';
	$sql = "DROP TABLE IF EXISTS $table";
	$query = $connection->prepare($sql);
	$query->execute();
	
	$sql="CREATE TABLE IF NOT EXISTS magetsu.$table ( name VARCHAR(100) NOT NULL,
												   year INT NOT NULL,
												   orgname VARCHAR(100) NOT NULL,
												   barcode VARCHAR(20) NOT NULL,
												   director VARCHAR(100) NOT NULL,
												   music VARCHAR(100) NOT NULL,
												   other VARCHAR(1000) NOT NULL)";

	$query = $connection->prepare($sql);
	$query->execute();

}

// Tietokanta tytetn tiedolla joka on saatu XML:st
function populate_database($library,$user_id) {

	global $connection;
	$i=0;
	
	$table = 'magetsu.'.$user_id.'book';
	
	$sql = "INSERT INTO $table (surname, forename, bookname, pubyear, isbn, orgname, orgyear, other) values ( ?, ?, ?, ?, ?, ?, ?,?)";

	while(is_object($books = $library->getElementsByTagName("book")->item($i))) {
			
		$array = array();

		foreach($books->childNodes as $nodename) {

			if ($nodename->nodeType==XML_ELEMENT_NODE) {
					
				array_push($array,$nodename->nodeValue);
			}
		}

		$query = $connection->prepare($sql);
		$query->execute($array);
		$i++;
	}

	$i=0;
	$table = 'magetsu.'.$user_id.'dvd';
	$sql = "INSERT INTO $table (name, year, orgname, barcode, director, music, other) values(?, ?, ?, ?, ?, ?, ?)";

	while(is_object($dvds = $library->getElementsByTagName("dvd")->item($i))) {
			
		$array = array();

		foreach($dvds->childNodes as $nodename) {

			if ($nodename->nodeType==XML_ELEMENT_NODE) {
					
				array_push($array,$nodename->nodeValue);
			}
		}

		$query = $connection->prepare($sql);
		$query->execute($array);
		$i++;
	}

}

// Luodaan tietokannan sisllst XML
function create_xml($user_id) {
	
	global $connection;
	
	$table_book = 'magetsu.'.$user_id.'book';
	$sql = "SELECT * FROM $table_book";
	$query = $connection->prepare($sql);
	$query->execute();
	$array = $query->fetchAll();
	create_book_tree($array);
	
	$table_dvd = 'magetsu.'.$user_id.'dvd';
	$sql = "SELECT * FROM $table_dvd";
	$query = $connection->prepare($sql);
	$query->execute();
	$array = $query->fetchAll();
	
}

function create_book_tree($array) {

	$domtree = new DOMDocument('1.0', 'UTF-8');
	$xmlRoot = $domtree->createElement("xml");
	$xmlRoot = $domtree->appendChild($xmlRoot);
	$currentBook = $domtree->createElement("book");
	$currentBook = $xmlRoot->appendChild($currentBook);
	
	echo $domtree->saveXML();
}